#ifndef __CONCEPTTYPES_H
#define __CONCEPTTYPES_H

#include "AnsiString.h"
#include "AnsiList.h"

typedef struct {
    AnsiString Name;
    int def_start;
    int def_end;
    AnsiList Members;
    char in_include;
} ClassContainer;

typedef struct {
    AnsiString Name;
    AnsiString Hint;
    int def_start;
    int def_end;
    AnsiList Variables;
    int Type;
    char fun_type;
    char in_include;
    char access;
    AnsiString linked_member;
} ClassMember;

typedef struct {
    AnsiString Name;
    AnsiString Content;
    int        ses_requested;
    int        last_mod;
    //AnsiString last_mod;
} Included;

#define V_DELEGATE   -4
#define V_ARRAY      -3
#define V_STRING     -2
#define V_NUMBER     -1

typedef struct {
    AnsiString Name;
    int Type;
} Variable;
#endif //__CONCEPTTYPES_H
