//#define OLDEST_WINDOWS

#define GLIBMM_PROPERTIES_ENABLED

#include <gtkmm.h>
#include <gtkmm/window.h>

#include "ConceptClient.h"
#include "AnsiList.h"
#include "base64_mime.h"
#include <iostream>
#include <time.h>
//#include "html.h"
//#include <libgnome/libgnome.h>


#ifdef _WIN32
	#include <direct.h> // chdir
#endif

#include "callback.h"

#define COPYRIGHT_NOTICE    "Concept Client 1.0 (c) 2007 RadGs Software (www.radgs.com)\n"\
                            "For interpreter core version 1.0.x & Concept Framework 1.1\n"\
                            "Client built using the gtkmm library (check GTKmm and dependencies licenses).\n"

//-----------------------------------------------------------------------------------------
long C_GetString(
        const char *lpAppName,
        const char *lpKeyName,
        const char *lpDefault,
        char *lpReturnedString,
        long nSize,
        const char * lpFileName) 
{
    FILE *in=0;
    long filesize=0;
    char *filebuffer=0;
    char section_name[4096];
    char key_name[4096];
    int error=0;

    in=fopen(lpFileName,"rb");
    if (in) {
        fseek(in, 0L, SEEK_END);
        filesize=ftell(in);
        fseek(in, 0L, SEEK_SET);
        if (filesize) {
            filebuffer=new char[filesize];
            if (filebuffer) {
                if (fread(filebuffer,1,filesize,in)==filesize) {
                    char in_name=0;
                    char in_quote=0;
                    char in_looked_section=0;
                    char in_looked_key=0;
                    char in_looked_value=0;
                    char in_comment=0;
                    char in_key=0;
                    int  temp_pos=0;
                    int key_pos=0;
                    int value_pos=0;

                    section_name[0]=0;
                    key_name[0]=0;

                    int i;
                    for (i=0;i<filesize;i++) {
                        if (in_comment) {
                            if ((filebuffer[i]=='\n') || (filebuffer[i]=='\r'))
                                in_comment=0;
                            continue;
                        }

                        if (((filebuffer[i]=='\n') || (filebuffer[i]=='\r')) && (in_looked_value)) {
                            lpReturnedString[value_pos++]=0;
                            break;
                        }

                        if (!in_quote) {
                            if (filebuffer[i]==';') {
                                if (in_looked_value)
                                    break;
                                in_comment=1;
                                continue;
                            }

                            if (filebuffer[i]=='[') {
                                // a inceput o sectziune noua, iar sectziunea precedenta este cea cautata ...
                                if (in_looked_section) {
                                    error=1;
                                    break;
                                }
                                temp_pos=0;
                                in_name=1;
                                continue;
                            }
                            if (in_name) {
                                if (filebuffer[i]==']') {
                                    in_name=0;
                                    section_name[temp_pos]=0;
                                    if (!strcmp(section_name,lpAppName))
                                        in_looked_section=1;
                                    continue;
                                }
                                if ((filebuffer[i]=='\n') || (filebuffer[i]=='\r')) {
                                    in_name=0;
                                    continue;
                                }
                                if (in_name)
                                    section_name[temp_pos++]=filebuffer[i];
                            }
                        }
                        // schimb flag-ul de ghilimele, daca le-am gasit ...
                        if (!in_name) {
                            if (filebuffer[i]=='"') {
                                in_quote=!in_quote;
                                continue;
                            }
                            if (((filebuffer[i]=='\n') || (filebuffer[i]=='\r')) && (in_quote)) {
                                in_quote=0;
                                continue;
                            }
                        }

                        if (in_looked_key) {
                           if (filebuffer[i]=='=') {
                               in_looked_value=1;
                               continue;
                           }
                           if (in_looked_value) {
                               if (value_pos<nSize-1) {
                                  if (value_pos)
                                     lpReturnedString[value_pos++]=filebuffer[i];
                                  else if ((filebuffer[i]!=' ') && (filebuffer[i]!='\t'))
                                     lpReturnedString[value_pos++]=filebuffer[i];
                               } else {
                                   lpReturnedString[value_pos++]=0;
                                   break;
                               }
                               continue;
                           }
                        }

                        if (in_looked_section) {
                            if (((filebuffer[i]>='0') && (filebuffer[i]<='9')) ||
                               ((filebuffer[i]>='a') && (filebuffer[i]<='z')) ||
                               ((filebuffer[i]>='A') && (filebuffer[i]<='Z')) ||
                               (filebuffer[i]=='_')) {
                                   if (in_key==0) {
                                       key_pos=0;
                                       in_key=1;
                                   }
                                   key_name[key_pos++]=filebuffer[i];

                               } else {
                                   if (in_key) {
                                       key_name[key_pos]=0;
                                       if (!strcmp(key_name,lpKeyName))
                                          in_looked_key=1;
                                       in_key=0;
                                   }
                               }
                            // TO DO ... sunt in sectiunea cautata ...
                        }
                    }
                    // in caz ca e ultima linie din fisier ...
                    if ((i==filesize) && (in_looked_value))
                        lpReturnedString[value_pos++]=0;
                } else
                    error=1;
            } else
                error=1;
        } else
            error=1;
        fclose(in);
    } else {
        std::cerr << "Warning: Error reading from " << lpFileName << "\n";
        error=1;
    }

    if (error)
        strncpy(lpReturnedString, lpDefault, nSize);
    return (long)in;
}
//-----------------------------------------------------------------------------
int GetKey(char *value,char *ini_name, char *section, char *key, char *def) {
   return C_GetString(section,key,def,value,1024,ini_name);
}
//-----------------------------------------------------------------------------------------
int LoadFromFile(char *file, char *buffer2, char *buffer3, char *buffer4) {
    std::cerr << "Using shortcut " << file << "\n";

    if (file[0]=='"')
        file++;
    int len=strlen(file);
    if ((len) && (file[len-1]=='"'))
        file[len-1]=0;

    GetKey(buffer2,file,"Shortcut","Host","localhost");
    GetKey(buffer3,file,"Shortcut","Application","demo.con");
    GetKey(buffer4,file,"Shortcut","Secured","");
    if ((buffer4[0]=='1') || (buffer4[0]=='Y') || (buffer4[0]=='y') || (buffer4[0]=='T') || (buffer4[0]=='t'))
        strcpy(buffer4,"secured");
    else
        buffer4[0]=0;

    return 0;
}
//-----------------------------------------------------------------------------------------
#ifdef _WIN32
    #ifndef OLDEST_WINDOWS
        extern "C" WINBASEAPI HWND WINAPI GetConsoleWindow();
    #endif
#endif

void ShowConsole(int show) {
#ifdef _WIN32
    #ifndef OLDEST_WINDOWS
        static HWND hConsole=0;
        if (!hConsole)
            hConsole = GetConsoleWindow();
            //hConsole    =   GetActiveWindow();
        if (hConsole)
            ShowWindow(hConsole, show ? SW_SHOW : SW_HIDE);
    #endif
#endif
}
//-----------------------------------------------------------------------------------------
int main(int argc, char **argv) {
    char buffer1[1024];
    char buffer2[1024];
    char buffer3[1024];
    char buffer4[1024];
    char buffer5[1024];
    char buffer6[1024];
    char buffer7[1024];

    buffer1[0]=0;
    buffer2[0]=0;
    buffer3[0]=0;
    buffer4[0]=0;
    buffer5[0]=0;
    buffer6[0]=0;
    buffer7[0]=0;

    for (int i=0;i<argc;i++) {
        switch (i) {
	        case 0:
		        strncpy(buffer1,argv[i],1024);
		        break;
	        case 1:
		        strncpy(buffer2,argv[i],1024);
		        break;
	        case 2:
		        strncpy(buffer3,argv[i],1024);
		        break;
	        case 3:
		        strncpy(buffer4,argv[i],1024);
		        break;
	        case 4:
		        strncpy(buffer5,argv[i],1024);
		        break;
	        case 5:
		        strncpy(buffer6,argv[i],1024);
		        break;
	        case 6:
		        strncpy(buffer7,argv[i],1024);
		        break;
        }
    }

    std::cerr << COPYRIGHT_NOTICE;    
    if (buffer2[0]==0) {
        std::cerr << "\nUsage   : " << buffer1 << " server_addres application_name [secured]";
        std::cerr << "\nExample : " << buffer1 << " localhost HelloWorld.con";
        std::cerr << "\n          or if you use a Server Shortcut file (.ss)";
        std::cerr << "\n          " << buffer1 << " shortcut.ss\n";
        return -1;
    } else if (buffer3[0]==0) {
        LoadFromFile(AnsiString(buffer2),buffer2,buffer3,buffer4);
    }
    srand( (unsigned)time( NULL ) );

    AnsiString host=buffer2;
    AnsiString file=buffer3;
    AnsiString secured=buffer4;
    int is_debug=(int)(secured==(char*)"debug");
    int pipestream=AnsiString(buffer5).ToInt();

    if (file==(char*)"") {
        file=host;
        host="localhost";
    }

    /*gnome_program_init("Concept Client", "1.0", 
                        LIBGNOME_MODULE,
                        argc, argv,
                        NULL,
                        GNOME_PARAM_NONE);
    html_init();*/

    Gtk::Main kit(0, 0);


    CConceptClient CC(MESSAGE_CALLBACK,(int)(secured==(char*)"secured"),is_debug);
    if (CC.NoErrors()) {
        AnsiString path=GetDirectory();
        MESSAGE_INIT(&CC,path+"client",host);
        std::cerr << "\nPowering up Concept Client ...\n";
        std::cerr << ":::::::::::::::::: Contacting server ...";
        if (CC.Connect(host,DEFAULT_PORT)) {
            std::cerr << "\r[]:::::::::::::::: Connection is now secured !";
            std::cerr << "\r[][]:::::::::::::: Running " << file;// << "\n";
            CC.Run(file,pipestream);
            std::cerr << "\r[][][][][][][]:::: Loading custom controls ...                               ";

            LoadControls(path+COMPONENTS);

            // set path ...
            path+=COOKIES;
            chdir(path.c_str());

            std::cerr << "\r[][][][][][][][]:: Initializing messaging system ...                         ";

            CC.StartMessaging();
            CC.WaitStartup();
            std::cerr << "\r[][][][][][][][][] All done. Ready !                                         \n";

            bool out=false;
            while (!RunApplication()) {
                /*if (!CC.PreLoopMessage())
                    Sleep(10);
                else {
                    out=true;
                    break;
                }*/
                if (CC.Iterate()) {
                    out=true;
                    break;
                }
            }

            if ((!out) && (RunApplication()>0)) {
                // begin the gtk window loop
                Gtk::Window *mainform=AppWindow();
                if (mainform) {
                    ShowConsole(0);
                    // build hooks
                    Glib::signal_idle().connect(sigc::mem_fun(CC,&CConceptClient::on_idle_event));
                    // end of hooks
                    CC.NotifyStartLoop();

                    Gtk::Main::run(*mainform);

                    ShowConsole(1);
                    if (RunApplication()==1) {
                        CC.SendMessage("%CLIENT",MSG_APPLICATION_QUIT,"0","0");
                        while (RunApplication()==1) {
                            //Sleep(5000);
                            CC.on_idle_event();
                        }
                    }
                }
            } else {
                if (RunApplication()==-1)
                    std::cerr << "\nAborting with run-time error(s).\n";            }
        } else {
            std::cerr << "\nError connecting to server at " << host.c_str() << "\n";
            std::cerr << "\nCan't connect to specified host. Check your firewall settings or contact your network administrator.\n";
        }
    } else {
        std::cerr << "\nError loading library.\n";
    }
    QuitPending();
    std::cout.flush();
    std::cerr.flush();
    CC.Disconnect();
    UnloadControls();
    /*if (pipestream>0) {
        std::cout << "\nPress Enter to continue ...";
        std::cin.get();
    }*/
    return 0;
}
