#ifndef __GTKCONTROL_H
#define __GTKCONTROL_H
#include "callback.h"
#include <gtk/gtk.h>

class GTKControl {
    public:
        long ID;
        int type;
        char pack_type;
        void *ptr;
        void *tip;
        void *event_handler;
        void *extra_ptr;
        void *fixed_ptr;
        int parent_id;
        char extra_flags;
        short x;
        short y;

        GTKControl(int _parent_id) {
            ID=0;
            x=0;
            y=0;
            parent_id=_parent_id;
            type=0;
            pack_type=-1;
            ptr=0;
            tip=0;
            event_handler=0;
            extra_ptr=0;
            fixed_ptr=0;
            extra_flags=0;
        }

        ~GTKControl() {
            if (type==CLASS_TABLE)
                delete[] (int *)extra_ptr;
            // to do ...
            /*switch (type) {
                        case CLASS_FORM:
                                delete (Gtk::Window *)ptr;
                                break;
                        case CLASS_BUTTON:
                                delete (Gtk::Button *)ptr;
                                break;
                        case CLASS_CHECKBUTTON:
                                delete (Gtk::CheckButton *)ptr;
                                break;
                        case CLASS_RADIOBUTTON:
                                delete (Gtk::RadioButton *)ptr;
                                break;
                        case CLASS_EDIT:
                                delete (Gtk::Entry *)ptr;
                                break;
                        case CLASS_HBOX:
                                delete (Gtk::HBox *)ptr;
                                break;
                        case CLASS_VBOX:
                                delete (Gtk::VBox *)ptr;
                                break;
                        case CLASS_EVENTBOX:
                                delete (Gtk::EventBox *)ptr;
                                break;
                        case CLASS_VBUTTONBOX:
                                delete (Gtk::VButtonBox *)ptr;
                                break;
                        case CLASS_HBUTTONBOX:
                                delete (Gtk::HButtonBox *)ptr;
                                break;
                        case CLASS_HSEPARATOR:
                                delete (Gtk::HSeparator *)ptr;
                                break;
                        case CLASS_VSEPARATOR:
                                delete (Gtk::VSeparator *)ptr;
                                break;
                        case CLASS_LABEL:
                                delete (Gtk::Label *)ptr;
                                break;
                        case CLASS_FRAME:
                                delete (Gtk::Frame *)ptr;
                                break;
                        case CLASS_PROGRESSBAR:
                                delete (Gtk::ProgressBar *)ptr;
                                break;
                        case CLASS_VPANED:
                                delete (Gtk::VPaned *)ptr;
                                break;
                        case CLASS_HPANED:
                                delete (Gtk::HPaned *)ptr;
                                break;
                        case CLASS_SCROLLEDWINDOW:
                                delete (Gtk::ScrolledWindow *)ptr;
                                break;
                        case CLASS_IMAGE:
                                delete (Gtk::Image *)ptr;
                                break;
                        //case CLASS_ADJUSTMENT:
                        //        delete (Gtk::Adjustment *)ptr;
                        //        break;
                        case CLASS_VSCALE:
                                delete (Gtk::VScale *)ptr;
                                break;
                        case CLASS_HSCALE:
                                delete (Gtk::HScale *)ptr;
                                break;
                        case CLASS_HSCROLLBAR:
                                delete (Gtk::HScrollbar *)ptr;
                                break;
                        case CLASS_VSCROLLBAR:
                                delete (Gtk::VScrollbar *)ptr;
                                break;
                        case CLASS_SPINBUTTON:
                                delete (Gtk::SpinButton *)ptr;
                                break;
                        case CLASS_TEXTVIEW:
                                delete (Gtk::TextView *)ptr;
                                break;
                        case CLASS_ALIGNMENT:
                                delete (Gtk::Alignment *)ptr;
                                break;
                        case CLASS_NOTEBOOK:
                                delete (Gtk::Notebook *)ptr;
                                break;
                        case CLASS_ASPECTFRAME:
                                delete (Gtk::AspectFrame *)ptr;
                                break;
                        //case CLASS_MENUITEM:
                        //        delete (Gtk::MenuItem *)ptr;
                        //        break; 
                        //case CLASS_SEPARATORMENUITEM:
                        //        delete (Gtk::SeparatorMenuItem *)ptr;
                        //        break;
                        case CLASS_IMAGEMENUITEM:
                                delete (Gtk::ImageMenuItem *)ptr;
                                break;
                        case CLASS_TEAROFFMENUITEM:
                                delete (Gtk::TearoffMenuItem *)ptr;
                                break;
                        case CLASS_CHECKMENUITEM:
                                delete (Gtk::CheckMenuItem *)ptr;
                                break;
                        case CLASS_RADIOMENUITEM:
                                delete (Gtk::RadioMenuItem *)ptr;
                                break;
                        case CLASS_MENU:
                                delete (Gtk::Menu *)ptr;
                                break;
                        //case CLASS_MENUBAR:
                        //        delete (Gtk::MenuBar *)ptr;
                        //        break;
                        case CLASS_EXPANDER:
                                delete (Gtk::Expander *)ptr;
                                break;
                        case CLASS_VIEWPORT:
                                delete (Gtk::Viewport *)ptr;
                                break;
                        case CLASS_HANDLEBOX:
                                delete (Gtk::HandleBox *)ptr;
                                break;
                        case CLASS_TOOLBAR:
                                delete (Gtk::Toolbar *)ptr;
                                break;
                        case CLASS_TOOLBUTTON:
                                delete (Gtk::ToolButton *)ptr;
                                break;
                        case CLASS_TOOLSEPARATOR:
                                delete (Gtk::SeparatorToolItem *)ptr;
                                break;
                        case CLASS_MENUTOOLBUTTON:
                                delete (Gtk::MenuToolButton *)ptr;
                                break;
                        case CLASS_TOGGLETOOLBUTTON:
                                delete (Gtk::ToggleToolButton *)ptr;
                                break;
                        case CLASS_RADIOTOOLBUTTON:
                                delete (Gtk::RadioToolButton *)ptr;
                                break;
                        case CLASS_TREEVIEW:
                                delete (DeturnatedTreeView *)ptr;
                                break;
                        case CLASS_COMBOBOX:
                                delete (DeturnatedComboBox *)ptr;
                                break;
                        case CLASS_COMBOBOXTEXT:
                                delete (DeturnatedComboBoxEntry *)ptr;
                                break;
                        case CLASS_STATUSBAR:
                                delete (Gtk::Statusbar *)ptr;
                                break;
                        case CLASS_FIXED:
                                delete (Gtk::Fixed *)ptr;
                                break;
                        case CLASS_CALENDAR:
                                delete (Gtk::Calendar *)ptr;
                                break;
            }*/

            /*if (tip)
                delete (Gtk::Tooltips *)tip;
            if (event_handler)
                delete (ClientEventHandler *)event_handler;*/
        }
};

#endif //__GTKCONTROL_H
