#ifndef __COMUNICATOR_H
#define __COMUNICATOR_H

#include <sigc++/sigc++.h>
struct Parameters;

class Server {
    public:
        Server() { }
        virtual ~Server() { }
    
        virtual int message_notify(Parameters *param) {
            return m_signal_message_notify.emit(param);
        }

        //signal accessor:
        typedef SigC::Signal1<int, Parameters *> type_signal_message_notify;

        type_signal_message_notify signal_message_notify() {
            return m_signal_message_notify;
        }

    protected:
        type_signal_message_notify m_signal_message_notify;
};




#endif // __COMUNICATOR_H
