#ifndef __LOGIN_H
#define __LOGIN_H

#ifndef GLIBMM_PROPERTIES_ENABLED
    #define GLIBMM_PROPERTIES_ENABLED
#endif

#include <gtk/gtk.h>
#include "AnsiString.h"


class LoginDialog {
protected:
	GtkHBox *top_box;

	GtkHBox *user_box;
	GtkHBox *password_box;

	GtkHButtonBox *button_box;

	GtkImage *LoginImage;
	GtkLabel *LoginText;

	GtkLabel *UserLabel;
	GtkLabel *PassLabel;

	GtkEntry *UserEntry;
	GtkEntry *PassEntry;

public:
    GtkDialog *handle;
	LoginDialog(char *image_file);

    void reset(char *username, char *password, char *hint);

    AnsiString GetPassword();
    AnsiString GetUsername();

    void hide();
    int run();

	virtual ~LoginDialog();
	
};



#endif // __LOGIN_H

